# Introduction

First of all, thank you for considering contributing to Project64! Project64 is an open-source project, and we love to receive contributions from the community. Contributions help fix bugs, add new features, and improve the project. There are many ways to contribute, from writing and improving the documentation, testing, submitting bug reports and feature requests, or writing code that can be incorporated into Project64 itself.

If you are looking for support or need help, please join the [Discord](https://discord.gg/Cg3zquF)! It's the best way to get your questions answered quickly. Please do not open a GitHub issue without first reading through the [support document](../Docs/SUPPORT.md).

Following these guidelines will help ensure that users and developers alike can work together to achieve the project's goals.

Please do NOT post any copyrighted materials. This includes (but is not limited to) ROMs, ROM hacks, IPL and firmware files, etc.

Save states and game saves do not fall under this category, so please post them only if they are applicable to your issue!

# Github Contribution Guide

1. Create a fork of this repository on your own account.
2. Create a new branch from the `develop` branch.
  * Choose a meaningful name for the branch (e.g. `fix`, `documentation`).
3. Commit any changes onto your new branch.
4. If sensible, squash all commits into one. This helps clean up the vetting process.
  * Ensure that commit messages are clear, concise, and informative. They should include information about all changes made, especially when squashing multiple commits into one.
5. Once all commits have been made and squashed, rebase all changes in your branch.
  * Rebasing will resolve any merge confilcts that your changes may cause.
6. Create a pull request to the `develop` branch
  * The pull request should be descriptive and include all changes made to the code base. If multiple files have been changed, organize them such that they can be easily followed by a reviewer.
  * Make sure that you **allow edits** by maintainers when making the Pull Request.
7. Your changes should be reviewed and fixes may be made to your changes.
  * If fixes are made please make sure to address them.

